<h1 id="h_01HG1HMWYS84C2NPE07P4SW9JZ">Overview</h1>
<p>In some cases, you may wish to specify your secrets to pull a private image inside your Container Runner instead of your <code>config.yml</code> in CircleCI. </p>
<p>To do so, please follow the instructions below. </p>
<p> </p>
<h1 id="h_01HG1HPHM52ZCSBA16JN90JN23">Google Container Registry / Google Artifact Registry</h1>
<h3 id="h_01HG1HQ2JGSQ97SZ82456STVMY">Step 1 - Create your access credentials per the <a href="https://developers.google.com/workspace/guides/create-credentials" target="_blank" rel="noopener noreferrer">Google Cloud documentation</a>
</h3>
<p>You will need to verify that your access credentials include the correct permissions to pull and/or push your image.</p>
<p> </p>
<h3 id="h_01HG1HTCKG20ECB4H1YR1EX8C9">Step 2 - Create a Secret in your Container Runner's Namespace</h3>
<h4 id="h_01HG1MN3J19884C561P2KWW0FR">Google Container Registry:</h4>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor="">$ NAMESPACE=&lt;namespace&gt;<br>$ SECRET_NAME=&lt;secret_name&gt;<br>$ EMAIL=&lt;valid@email_address&gt;<br>$ kubectl create secret docker-registry $SECRET_NAME -n $NAMESPACE \<br>    --docker-server=gcr.io \<br>    --docker-username=_json_key \<br>    --docker-password="$(cat ~/json-key-file.json)" \<br>    --docker-email=$EMAIL</pre>
<h4 id="h_01HG1MP4TGN415R1MBPWAQP7CP"> </h4>
<p>Google Artifact Registry</p>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor="">$ NAMESPACE=&lt;namespace&gt;<br>$ SECRET_NAME=&lt;secret_name&gt;<br>$ REGION=&lt;region&gt;<br>$ EMAIL=&lt;valid@email_address&gt;<br>$ kubectl create secret docker-registry $SECRET_NAME -n $NAMESPACE \<br>    --docker-server=$REGION-docker.pkg.dev \<br>    --docker-username=_json_key \<br>    --docker-password="$(cat ~/json-key-file.json)" \<br>    --docker-email=$EMAIL</pre>
<p>In both examples, the <code>json-key-file.json</code> is the key you have downloaded from creating your access credentials.</p>
<p> </p>
<h3 id="h_01HG1HZP5XXF7D3W2CNYM28P2V">Step 3 - Update your <code>imagePullSecrets</code> in your <code>values.yaml</code>
</h3>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor=""># values.yaml<br>agent:<br>  resourceClasses:<br>    &lt;namespace&gt;/&lt;resource_class_name&gt;:<br>      toke: &lt;token&gt; <br>      spec:<br>        imagePullSecrets:<br>          - name: "&lt;secret_name&gt;"</pre>
<p> </p>
<h3 id="h_01HG1J3WVYH6KXXVAQCWNK318E">Step 4 - Update your Container Runner Deployment</h3>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor="">$ NAMESPACE=&lt;namespace&gt;<br>$ VALUES_FILE=&lt;values_file&gt;<br>$ helm upgrade container-agent container-agent/container-agent -n $NAMESPACE -f $VALUES_FILE</pre>
<p> </p>
<h1 id="h_01HG1JXDKZ0PY6GVCG88GBCSAN">AWS Elastic Container Registry</h1>
<h3 id="01HG1JXQ6CFKF90TG2SGB2RZ8R">Step 1 - Confirm you have run <code>aws configure</code>.</h3>
<p>This will need to be run for <code>aws ecr get-login-password</code> to properly function.</p>
<p>Please take note of the user and the permissions that this user has.</p>
<p> </p>
<h3 id="01HG1JXQ6CT2GT04B28EHC0GJX">Step 2 - Create a Secret in your Container Runner's Namespace</h3>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor="">$ NAMESPACE=&lt;namespace&gt;<br>$ SECRET_NAME=&lt;secret_name&gt;<br>$ AWS_ACCOUNT=&lt;aws_account_id&gt;<br>$ AWS_REGION=&lt;aws_region&gt;<br>$ kubectl create secret docker-registry $SECRET_NAME -n $NAMESPACE \<br>    --docker-server=${AWS_ACCOUNT}.dkr.ecr.${AWS_REGION}.amazonaws.com \<br>    --docker-username=AWS \<br>    --docker-password=$(aws ecr get-login-password) </pre>
<p> </p>
<h3 id="01HG1JXQ6C2WWFG8F7G7HZEVVP">Step 3 - Update your <code>imagePullSecrets</code> in your <code>values.yaml</code>
</h3>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor=""># values.yaml<br>agent:<br>  resourceClasses:<br>    &lt;namespace&gt;/&lt;resource_class_name&gt;:<br>      toke: &lt;token&gt; <br>      spec:<br>        imagePullSecrets:<br>          - name: "&lt;secret_name&gt;"</pre>
<p> </p>
<h3 id="01HG1JXQ6DC5VS83XMBZT9N076">Step 4 - Update your Container Runner Deployment</h3>
<pre style="background-color: #f3f3f3; padding: 5px;" data-darkreader-inline-bgcolor="">$ NAMESPACE=&lt;namespace&gt;<br>$ VALUES_FILE=&lt;values_file&gt;<br>$ helm upgrade container-agent container-agent/container-agent -n $NAMESPACE -f $VALUES_FILE</pre>
<p> </p>
<p> </p>
<h2 id="h_01HG1J69CMDGTX4TFNHGQAKJPV">Additional Resources</h2>
<ul>
    <li><a href="https://support.circleci.com/hc/en-us/articles/15773444776731">How to use customSecret on Container Runner</a></li>
    <li><a href="https://github.com/CircleCI-Public/container-runner-helm-chart/blob/50c46581b38a04641566813d9a2dd77f64db1ee9/values.yaml#L190-L191" target="_blank" rel="noopener noreferrer">imagePullSecret Container Runner Helm Reference</a></li>
    <li><a href="https://blog.container-solutions.com/using-google-container-registry-with-kubernetes" target="_blank" rel="noopener noreferrer">Using Google Container Registry with Kubernetes</a></li>
    <li><a href="https://docs.garden.io/kubernetes-plugins/remote-k8s/configure-registry/gcp#enabling-in-cluster-building-with-google-artifact-registry" target="_blank" rel="noopener noreferrer">Using Google Artifact Registry with Kubernetes</a></li>
    <li><a href="https://skryvets.com/blog/2021/03/15/kubernetes-pull-image-from-private-ecr-registry/" target="_blank" rel="noopener noreferrer">Using Elastic Container Registry with Kubernetes</a></li>
</ul>